clear
clc
close all

filtersize = 20;
sigma = 3;

isRGB = 1;
numIterOuter = 30;
numIterInner = 30;
threshold = 0.000005;

for imNum = 1:14
    for usePhase = 0:1
        disp('____________________________________________________ ');
        disp(['Processing im' num2str(imNum) ' for usePhase = ' num2str(usePhase)]);
        
        filename = ['inputs/' num2str(imNum) '.png'];
        imgOrg = double(imread(filename))/255;
        numchannels = 1;
        if isRGB 
            numchannels = 3;
        end
        for chann=1:numchannels
            disp(['-----Processing channel ' num2str(chann)]);
            img = imgOrg(:,:,chann);
            filter = z_createFilter('gaussian', sigma, filtersize);
            blurred = conv2(img, filter, 'same');

            blurred = blurred(filtersize + 1:end - filtersize,filtersize + 1:end - filtersize);

            [sx,sy] = size(blurred);

            %add window to both f_k and blurred
            mask = ones(sx,sy);
            blurredWindowed = padarray(blurred,  ceil([sx/2, sy/2]), 'replicate', 'pre');
            blurredWindowed = padarray(blurredWindowed, floor([sx/2, sy/2]), 'replicate', 'post');

            mask = padarray(mask,  ceil([sx/2, sy/2]), 0, 'pre');
            mask = padarray(mask, floor([sx/2, sy/2]), 0, 'post');


            guessedSigma = 5;
            guessedFilterSize = 30;
            g_k = z_createFilter('gaussian', guessedSigma, guessedFilterSize);

            blurredMask = conv2(mask, g_k, 'same');
            blurredWithMask = blurredWindowed .* blurredMask;

            %%% start f_k as the blurry image itself:
            if usePhase
                f_k = blurredWithMask;
            else
                f_k = blurred;
            end
            %%%
            f_k_1 = f_k;

            total=sum(f_k(:));

            z_go;
            if chann == 1
                result = f_k;
                colorblurr = blurred;
            else
                result(:,:,chann) = f_k;
                colorblurr(:,:,chann) = blurred;
            end
        end
        g_k = g_k / max(g_k(:));
        if (usePhase == 0)
            imwrite(imgOrg ,['Results/' num2str(imNum) '_1_original.png']);
            imwrite(colorblurr ,['Results/' num2str(imNum) '_2_blurred.png']);
            imwrite(result,['Results/' num2str(imNum) '_3_lucy.png']);
            imwrite(g_k,['Results/' num2str(imNum) '_5_lucy_filter.png']);
            save(['Mat Results/' num2str(imNum) '_Lucy.mat'], 'imgOrg', 'blurred', 'result', 'g_k');
        else
            imwrite(result(ceil(sx/2)+1:end-floor(sx/2), ceil(sy/2)+1:end-floor(sy/2),:),['Results/' num2str(imNum) '_4_Phase.png']);
            imwrite(g_k, ['Results/' num2str(imNum) '_6_Phase_filter.png']);
            save(['Mat Results/' num2str(imNum) '_Phase.mat'], 'imgOrg', 'blurredWithMask', 'result', 'g_k');
        end
    end
end