for kk = 1:numIterOuter
    disp(['Iteration ' num2str(kk) ' of ' num2str(numIterOuter)]);
    disp(' Estimating g_k');

    if usePhase
        g_k = z_lucy(blurredWithMask, f_k(ceil(sx/2)+1:end-floor(sx/2), ceil(sy/2)+1:end-floor(sy/2)), numIterInner);
    else
        g_k = z_lucy(blurred, f_k, numIterInner);
    end
    %When g_k is estimated, update blurredWithMask:

    g_k = g_k(ceil(size(g_k,1)/2)-20:end-(ceil(size(g_k,1)/2)-20),ceil(size(g_k,2)/2)-20:end-(ceil(size(g_k,2)/2)-20));
    g_k = g_k / sum(g_k(:));
    g_k(g_k > 1) = 1;
    g_k(g_k < 0) = 0;
    if usePhase
        blurredMask = conv2(mask, g_k, 'same');
        blurredWithMask = blurredWindowed .* blurredMask;
        angles = angle(fft2(blurredWithMask));
    end
    disp(' Estimating f_k');
    if usePhase
        f_k = z_lucy(blurredWithMask, g_k(), numIterInner);
    else
        f_k = z_lucy(blurred, g_k, numIterInner);
    end
    if usePhase
        %Apply Phase Constraint:
        F_k = fft2(f_k);
        F_k(abs(F_k)>1) = abs(F_k(abs(F_k)>1)).*exp(1i*angles(abs(F_k)>1));
        f_k = real(ifft2(F_k));
        %Apply Spatial Domain Constraint
        f_k = f_k .* mask;
        f_k = (f_k * sum(blurredWithMask(:))) / sum(f_k(:));
    end
    f_k = total * f_k / sum(f_k(:));
    f_k(f_k > 1) = 1;
    f_k(f_k < 0) = 0;
    if usePhase
        %display iteration results:
        subplot(1,4,1)
        imshow(img(filtersize + 1:end - filtersize,filtersize + 1:end - filtersize));
        title('Original image')
        subplot(1,4,2)
        imshow(blurredWithMask(ceil(sx/2)+1:end-floor(sx/2), ceil(sy/2)+1:end-floor(sy/2)));
        title('Image inside Window with Blur Estimate')
        subplot(1,4,3)
        imshow(f_k(ceil(sx/2)+1:end-floor(sx/2), ceil(sy/2)+1:end-floor(sy/2)));
        title(['Image estimate in iteration ' num2str(kk) ' of ' num2str(numIterOuter)]);
        subplot(1,4,4)
        imshow(g_k,[]);
        title('Filter estimate (Normalized)');
    else
        %display iteration results:
        subplot(1,4,1)
        imshow(img(filtersize + 1:end - filtersize,filtersize + 1:end - filtersize));
        title('Original image')
        subplot(1,4,2)
        imshow(blurred);
        title('Image with Blur Estimate')
        subplot(1,4,3)
        imshow(f_k);
        title(['Image estimate in iteration ' num2str(kk) ' of ' num2str(numIterOuter)]);
        subplot(1,4,4)
        imshow(g_k,[]);
        title('Filter estimate (Normalized)');
    end

    pause(0.1);
    avg_err = sum(sum(abs(f_k - f_k_1)))/numel(f_k);
    disp([' Average error is ' num2str(avg_err)]);
    if (avg_err < threshold || chann == 1)
        break;
    end
    f_k_1 = f_k;
end